Index: asterisk-11.7.0~dfsg/res/res_xmpp.c
===================================================================
--- asterisk-11.7.0~dfsg.orig/res/res_xmpp.c	2015-04-22 17:34:57.027326914 -0500
+++ asterisk-11.7.0~dfsg/res/res_xmpp.c	2015-04-24 17:14:57.652114261 -0500
@@ -1487,6 +1487,30 @@
 	return CMP_MATCH | CMP_STOP;
 }
 
+static int xmpp_resource_prio_cmp(void *obj, void *arg, int flags)
+{
+	struct ast_xmpp_resource *resource1 = obj;
+	int *prio = arg;
+
+	if (resource1->priority == *prio) {
+		return (CMP_MATCH | CMP_STOP);
+	}
+
+	return 0;
+}
+
+static int xmpp_resource_max_prio_cmp(void *obj, void *arg, int flags)
+{
+	struct ast_xmpp_resource *resource1 = obj;
+	int *max_prio = arg;
+
+	if (resource1->priority > *max_prio) {
+		*max_prio = resource1->priority;
+	}
+
+	return 0;
+}
+
 /*
  * \internal
  * \brief Dial plan function status(). puts the status of watched user
@@ -1582,6 +1606,8 @@
 	struct ast_xmpp_buddy *buddy;
 	struct ast_xmpp_resource *resource;
 	int stat = -1;
+	int max_prio = 0;
+
 	AST_DECLARE_APP_ARGS(args,
 			     AST_APP_ARG(sender);
 			     AST_APP_ARG(jid);
@@ -1619,7 +1645,8 @@
 	}
 
 	if (ast_strlen_zero(jid.resource) || !(resource = ao2_callback(buddy->resources, 0, xmpp_resource_cmp, jid.resource))) {
-		resource = ao2_callback(buddy->resources, OBJ_NODATA, xmpp_resource_immediate, NULL);
+		ao2_callback(buddy->resources, OBJ_NODATA, xmpp_resource_max_prio_cmp, &max_prio);
+		resource = ao2_callback(buddy->resources, 0, xmpp_resource_prio_cmp, &max_prio);
 	}
 
 	ao2_ref(buddy, -1);
